<template>
	<transition name="fade">
		<product-slider
			:is-loading="loading"
			:collection="collection"
			:item-list="itemList"
			:title="title"
		/>
	</transition>
</template>

<script>
	module.exports = {
		data() {
			return {
				collection: [],
				loading: false,
			};
		},
		props: ["product_ids", "title", "itemList"],
		components: {
			ProductSlider: `url:${jsBaseUrl}vue/ok_components/general/product-widget/ProductSlider.vue?v=${smsGeneralJsVersion}`,
		},
		methods: {
			getProducts() {
				if (!this.product_ids) return;
				this.loading = true;
				const productIds = Array.isArray(this.product_ids)
					? this.product_ids.join(",")
					: this.product_ids;

				const data = {
					params: {
						product_ids: productIds,
						novc: true,
					},
				};

				this.$http
					.get("related/index/getSliderProducts", data)
					.then(response => {
						this.collection = Array.isArray(response.body) ? response.body : [];
						this.loading = false;
					});
			},
		},
		mounted() {
			this.getProducts();
		},
		watch: {
			product_ids(newIds, oldIds) {
				if (newIds && newIds !== oldIds) {
					this.getProducts();
				}
			},
		},
	};
</script>
